
; 
    .model small,c
    .586
    .stack

    include support.asm

.data
    ts  dq 0  
.code
.startup

    ; Values for a 2-second delay.
    CYCLECOUNT  EQU 36
    LASTCOUNT   EQU 27068

    ; Set the gate for timer 2 (bit 0 at I/O port 61h) to off.
    ; To avoid changing other bits in the register, read the
    ; current value, clear bit 0, and write the altered value
    ; back.
    mov   dx,61h
    in    al,dx
    and   al,not 1
    out   dx,al

    ; Program timer 2 for LSB then MSB, mode 0, binary.
    ; The system timer control word register is at I/O
    ; port 43h. The system timer control word is set as
    ; follows:
    ;   bit 7-6: 10     = timer 2
    ;   bit 5-4: 11     = R/W LSB then MSB
    ;   bit 3-1: 000    = single timeout
    ;   bit 0:   0      = binary
    mov   dx,43h
    mov   al,0b0h
    out   dx,al

    ; Get starting value for TSC.
    rdtsc
    mov   dword ptr ts,eax
    mov   dword ptr ts+4,edx

    ; Do the full range cycles.
    mov   cx,CYCLECOUNT
  L1:
    ; Load the starting value, LSB then MSB.
    mov   dx,42h
    xor   al,al
    out   dx,al
    out   dx,al
    ; Set the gate for timer 2 (bit 0 at I/O port 61h) to on.
    mov   dx,61h
    in    al,dx
    or    al,1
    out   dx,al
    ; Wait until the output bit (bit 5 at I/O port 61h) is set.
  @@:
    in    al,dx
    test  al,20h
    jz    @B
    sub   cx,1
    jnz   L1

    ; Do the last cycle.
    ; Set the gate for timer 2 (bit 0 at I/O port 61h) to off.
    mov   dx,61h
    in    al,dx
    and   al,not 1
    out   dx,al
    ; Load the starting value, LSB then MSB.
    mov   ax,LASTCOUNT
    mov   dx,42h
    out   dx,al
    mov   al,ah
    out   dx,al
    ; Set the gate for timer 2 (bit 0 at I/O port 61h) to on.
    mov   dx,61h
    in    al,dx
    or    al,1
    out   dx,al
    ; Wait until the output bit (bit 5 at I/O port 61h) is set.
  @@:
    in    al,dx
    test  al,20h
    jz    @B

    ; Set the gate for timer 2 (bit 0 at I/O port 61h) to off.
    mov   dx,61h
    in    al,dx
    and   al,not 1
    out   dx,al

    ; Get final TSC value and calc clock speed
    rdtsc
    sub   eax,dword ptr ts
    sbb   edx,dword ptr ts+4
    mov   ecx,2000000
    div   ecx

    invoke dw2dec,eax,ADDR outbuf
    print "CPU clock speed = ",ADDR outbuf

    print NL,"Press any normal key to exit...",NL
    call waitkey
; 
.exit

end
